#!/usr/bin/python3
# -*- coding: utf-8 -*-

import shutil
import os
from util import handle_int_option

tally_option = {"tally" : 0,
	        	"unlock_time" : 0,
	        	"deny" : 0,
		        "deny_root" : 0,
		        "root_unlock_time" : 0}
COM_AUTH = "/etc/pam.d/common-auth"
#BAK_AUTH = "/etc/pam.d/.common-auth"
SAVEDIR = "/usr/share/system-config-pam/"
CONFDIR = "/usr/share/pam-configs/"
tallyfile = CONFDIR + "tally2"
tallyconf = "\trequired\t\t\tpam_tally2.so "
#tallyconf = "password\trequired\tpam_tally2.so\t"

def get_account_lock():
    ret = tally_option

    try:
        fp = open(COM_AUTH,"r")
    except IOError as e:
        print("Cannot open common-auth",e)
        return
    else:    
        tmp = fp.readlines()
        fp.close()

    t = []
    for i in tmp:
        if i.strip().startswith("#") or ("tally" not in i):
            continue
        else:
            t.append(i.strip())

    if t != []:
        ret["tally"] = 1
        x = t[0].split()
        for i in x:
            if i.startswith("deny"):
                try:
                    ret["deny"] = int(i.split("=")[1])%65536
                except ValueError as e:
                    print("Get Invalid Options",e)
                    ret["deny"] = 0
            if i.startswith("unlock_time"):
                ret["unlock_time"] = handle_int_option(i.split("=")[1])
            if i == "even_deny_root":
                ret["deny_root"] = 1
            if i.startswith("root_unlock"):
                ret["deny_root"] = 1
                ret["root_unlock_time"] = handle_int_option(i.split("=")[1])
    return ret


def set_account_lock(option):
    try:
        shutil.copyfile(COM_AUTH, BAK_AUTH)
    except IOError as e:
        print("Cannot bakup common-auth", e)

    try:
        fp = open(COM_AUTH,"r")
    except IOError as e:
        print("Cannot read common-auth",e)
        raise e
    else:
        tmp = fp.readlines()
        fp.close()

    for i in tmp:
        if not i.startswith("#") and "pam_tally2.so" in i:
            tmp.remove(i)

    if option["tally"] == 0:
        t = ""
    else:
        if option["deny_root"] == 0:
            t = tallyconf + "deny=" + str(option["deny"]) +\
                " unlock_time=" + str(option["unlock_time"]) + "\n"
        else:
            t = tallyconf + "deny=" + str(option["deny"]) +\
                " unlock_time=" + str(option["unlock_time"]) + \
                " root_unlock_time=" + str(option["root_unlock_time"]) + "\n"
    for i in tmp:
        if not i.startswith("#") and "pam_unix.so" in i:
            c = tmp.index(i)
    tmp.insert(c,t)
    try:
        f = open(COM_AUTH,"w")
    except IOError as e:
        print("Write common-auth Failed", e)
        raise e
    else:
        f.writelines(tmp)
        f.close()


def set_tally2_config(option):
    if option["tally"] == 0:
        cmd = "rm -f " + tallyfile
        if os.path.exists(tallyfile):
            t = os.system(cmd)
            if t != 0:
                raise RuntimeError
        try:
            os.system("pam-auth-update --package --force")
        except OSError as e:
            print("Cannot set tally2")
            raise e

    else:
        if option["deny_root"] == 0:
            t = tallyconf + "deny=" + str(option["deny"]) +\
                " unlock_time=" + str(option["unlock_time"]) + "\n"
        else:
            t = tallyconf + "deny=" + str(option["deny"]) +\
                " unlock_time=" + str(option["unlock_time"]) + \
                " root_unlock_time=" + str(option["root_unlock_time"]) + "\n"

        if not os.path.exists(tallyfile):
            cmd = "cp " + SAVEDIR + "tally2 " + tallyfile
            c = os.system(cmd)
            if c != 0:
                print("Cannot initial tally2")
                raise RuntimeError

        try:
            f = open(tallyfile,"r")
        except IOError as e:
            print("Cannot read tally2 file")
            raise e
        else:
            tmp = f.readlines()
            f.close()

        for i in tmp:
            if "pam_tally2.so" in i:
                c = tmp.index(i)

        tmp[c] = t
        try:
            f = open(tallyfile,"w")
        except IOError as e:
            print("Cannot write tally2 file")
            raise e
        else:
            f.writelines(tmp)
            f.close()

        try:
            os.system("pam-auth-update --package --force")
        except OSError as e:
            print("Cannot set tally2")
            raise e
