#!/usr/bin/python3

import sys

from PyQt5.QtWidgets import QDialog, QDialogButtonBox
from PyQt5.QtWidgets import QApplication

from ui_passwdadvanceddialog import Ui_PasswdAdvancedDialog
import pwcomplex


class PasswdAdvancedDialog(QDialog):
    def __init__(self, parent = None):
        QDialog.__init__(self, parent)
        self.ui = Ui_PasswdAdvancedDialog()
        self.ui.setupUi(self)
        self.ui.buttonBox.button(QDialogButtonBox.Ok).setText("确定")
        self.ui.buttonBox.button(QDialogButtonBox.Cancel).setText("取消")
        self.init_PassAdvanceValue()

        self.ui.buttonBox.accepted.connect(self.onAcceptButtonClicked)

    def init_PassAdvanceValue(self):

        if "ret" in globals():
            my_advance = ret
        else:
            my_advance = pwcomplex.get_pw_advance()
            
        if my_advance["reject_username"] == 1:
            self.ui.radioButton.click()
        else:
            self.ui.radioButton_2.click()
        self.ui.upper_spin.setValue(my_advance["ucredit"])
        self.ui.lower_spin.setValue(my_advance["lcredit"])
        self.ui.digit_spin.setValue(my_advance["dcredit"])
        self.ui.other_spin.setValue(my_advance["ocredit"])
        self.ui.maxrepeat_spin.setValue(my_advance["maxrepeat"])
        self.ui.maxsequence_spin.setValue(my_advance["maxsequence"])
        self.ui.maxclass_spin.setValue(my_advance["maxclassrepeat"])

    def onAcceptButtonClicked(self):
        global ret
        ret = pwcomplex.pw_advance
        
        ret["ucredit"] = self.ui.upper_spin.value()
        ret["lcredit"] = self.ui.lower_spin.value()
        ret["dcredit"] = self.ui.digit_spin.value()
        ret["ocredit"] = self.ui.other_spin.value()
        ret["maxrepeat"] = self.ui.maxrepeat_spin.value()
        ret["maxsequence"] = self.ui.maxsequence_spin.value()
        ret["maxclassrepeat"] = self.ui.maxclass_spin.value()
        if self.ui.radioButton.isChecked():
            ret["reject_username"] = 1
        if self.ui.radioButton_2.isChecked():
            ret["reject_username"] = 0

        return ret


if __name__ == "__main__":
    app = QApplication(sys.argv)
    dialog = PasswdAdvancedDialog()
    dialog.show()
    app.exec_()
