#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
from util import handle_int_option

COM_PASS = "/etc/pam.d/common-password"
PASS_HISTORY = "/etc/security/opasswd"
SAVEDIR = "/usr/share/system-config-pam/"
CONFDIR = "/usr/share/pam-configs/"
crackfile = CONFDIR + "cracklib"
pwfile = CONFDIR + "pwhistory"
crackconf = "\trequired\t\tpam_cracklib.so\tdifok=0 "
historyconf = "\trequired\t\tpam_pwhistory.so\t"

pw_general = {  "crack" : 0,
            	"minlen" : 9,
        		"minclass" : 0,
                "history": 0,
        		"enforce_for_root": 0  }

pw_advance = {  "ucredit" : 0,
        		"lcredit" : 0,
        		"dcredit" : 0,
        		"ocredit" : 0,
        		"maxrepeat" : 0,
                "maxsequence" : 0,
        		"maxclassrepeat": 0,
                "reject_username" : 1  }

def get_pw_general():
    ret = pw_general 

    try:
        fp = open(COM_PASS,'r')
    except IOError as e:
        print("Cannot read common-passwd",e)
        return

    tmp = fp.readlines()
    fp.close()

    t = []
    for i in tmp:
        if i.strip().startswith("#"):
            continue
        elif ("cracklib.so" in i) or ("pwhistory.so" in i):
            t.append(i.strip())
        else:
            continue

    for i in t:
        if "pwhistory" in i:
            if "remember" not in i:
                ret["history"] = 10
            for x in i.split():
                if x.startswith("remember"):
                    ret["history"] = handle_int_option(x.split("=")[1])
                        
        if "cracklib" in i:
            ret["crack"] = 1
            for x in i.split():
                if x.startswith("minlen"):
                    ret["minlen"] = handle_int_option(x.split("=")[1])
                if x.startswith("minclass"):
                    ret["minclass"] = handle_int_option(x.split("=")[1])
                if x == "enforce_for_root":
                    ret["enforce_for_root"] = 1
    return ret

def get_pw_advance():
    try:
        fp = open(COM_PASS,'r')
    except IOError as e:
        print("Cannot read common-passwd",e)
        return

    tmp = fp.readlines()
    fp.close()

    ret = pw_advance
#    for i in ret:
#        ret[i] = 0
    t = ""
    for i in tmp:
        if i.strip().startswith('#') or ("cracklib.so" not in i):
            continue
        else:
            t = i

    if t != "":
        if "reject_username" not in t:
            ret["reject_username"] = 0

        for i in t.split():
            if i.startswith("upper_min="):
                ret["ucredit"] = handle_int_option(i.split("=")[1])
            if i.startswith("lower_min="):
                ret["lcredit"] = handle_int_option(i.split("=")[1])
            if i.startswith("digit_min="):
                ret["dcredit"] = handle_int_option(i.split("=")[1])
            if i.startswith("other_min="):
                ret["ocredit"] = handle_int_option(i.split("=")[1])
            if i.startswith("maxrepeat="):
                ret["maxrepeat"] = handle_int_option(i.split("=")[1])
            if i.startswith("maxsequence="):
                ret["maxsequence"] = handle_int_option(i.split("=")[1])
            if i.startswith("maxclassrepeat="):
                ret["maxclassrepeat"] = handle_int_option(i.split("=")[1])
    return ret
"""
def set_pw_strength(option) :
    try:
        shutil.copyfile(COM_PASS, BAK_PASS)
    except IOError as e :
        print("Cannot bakup common-passwd",e)

    try:
        f = open(COM_PASS,"r")
    except IOError as e:
        print("Cannot read common-passwd",e)
        raise e
    else:
        tmp = f.readlines()
        f.close()

    # Remove passwd strength setting first
    for i in tmp:
        if i.strip().startswith("#"):
            continue
        elif "passwdqc.so" in i or "pwquality.so" in i \
            or "cracklib.so" in i or "pwhistory.so" in i:
            tmp[tmp.index(i)] = ""


    if option["crack"] == 0:
        for i in tmp:
            if i.strip().startswith("#"):
                continue
            if "unix.so" in i:
                tmp[tmp.index(i)] = i.replace(" use_authtok","")
    else:
        h = historyconf + " remember=" + str(option["history"]) + "\n"
        c = crackconf + " minlen=" + str(option["minlen"]) +\
            " minclass=" + str(option["minclass"]) +\
            " upper_min=" + str(option["ucredit"]) +\
            " lower_min=" + str(option["lcredit"]) +\
            " digit_min=" + str(option["dcredit"]) +\
            " other_min=" + str(option["ocredit"]) +\
            " maxrepeat=" + str(option["maxrepeat"]) +\
            " maxsequence=" + str(option["maxsequence"]) +\
            " maxclassrepeat=" + str(option["maxclassrepeat"]) + "\n"
        # pam_unix             
        for i in tmp:
            if i.strip().startswith("#"):
                continue
            if "unix.so" in i:
                x = tmp.index(i)
                if "use_authtok" not in i:
                    tmp[x] = i.strip() + " use_authtok\n"

        if option["enforce_for_root"] == 1:
            h = h.strip() + " enforce_for_root\n"
            c = c.strip()+ " enforce_for_root\n"
        if option["reject_username"] == 1:
            c = c.strip() + " reject_username\n"
        tmp.insert(x,h)
        tmp.insert(x,c)

    try:
        f = open(COM_PASS,"w")
        hf = open(PASS_HISTORY,"w")
    except IOError as e:
        print("Write common-passwd failed", e)
        raise e
    else:
        f.writelines(tmp)
        hf.close()
        f.close()
"""

def set_pw_strength(option) :
    if option["crack"] == 0:
        cmd = "rm -f " + crackfile + " " + pwfile
        t = os.system(cmd)
        if t != 0:
            print("Cannot remove cracklib pwhistory")
            raise RuntimeError

        try:
            os.system("pam-auth-update --package --force")
        except OSError as e:
            print("Cannot set common-password", e)
            raise e

    else:
        h = historyconf + " remember=" + str(option["history"]) + "\n"
        c = crackconf + " minlen=" + str(option["minlen"]) +\
            " minclass=" + str(option["minclass"]) +\
            " upper_min=" + str(option["ucredit"]) +\
            " lower_min=" + str(option["lcredit"]) +\
            " digit_min=" + str(option["dcredit"]) +\
            " other_min=" + str(option["ocredit"]) +\
            " maxrepeat=" + str(option["maxrepeat"]) +\
            " maxsequence=" + str(option["maxsequence"]) +\
            " maxclassrepeat=" + str(option["maxclassrepeat"]) + "\n"
        if option["enforce_for_root"] == 1:
            h = h.rstrip() + " enforce_for_root\n"
            c = c.rstrip()+ " enforce_for_root\n"
        if option["reject_username"] == 1:
            c = c.rstrip() + " reject_username\n"
        if not os.path.exists(crackfile) or not os.path.exists(pwfile):
            cmd = "cp " + SAVEDIR + "cracklib " +\
                  SAVEDIR + "pwhistory " + CONFDIR
            t = os.system(cmd)
            if t != 0:
                print("Initial cracklib failed")
                raise RuntimeError
        try:
            f1 = open(crackfile,"r")
            f2 = open(pwfile, "r")
        except IOError as e:
            print("Cannot Read Passwd Conf")
        else:
            t1 = f1.readlines()
            f1.close()
            t2 = f2.readlines()
            f2.close()

        for i in t1:
            if i.startswith("Password:"):
                t1[t1.index(i)+1] = c.rstrip() + " use_authtok\n"
            if i.startswith("Password-Initial:"):
                t1[t1.index(i)+1] = c
        for i in t2:
            if i.startswith("Password:"):
                t2[t2.index(i)+1] = h.rstrip() + " use_authtok\n"
            if i.startswith("Password-Initial:"):
                t2[t2.index(i)+1] = h

        try :
            f1 = open(crackfile,"w")
            f2 = open(pwfile,"w")
            f3 = open(PASS_HISTORY, "w")
        except IOError as e:
            print("Cannot Write Passwd Conf")
            raise e
        else:
            f1.writelines(t1)
            f2.writelines(t2)
            f1.close()
            f2.close()
            f3.close()

        try:
            os.system("pam-auth-update --package --force")
        except OSError as e:
            print("Cannot Set common-password", e)
            raise e
